#!/usr/bin/perl -w
use Net::NNTP::Client;
sub isleapyear{
if (($_[0]%4)!=0) {return 0;}
if ((($_[0]%100)==0)&&(($_[0]%400)!=0)) {return 0;}
return 1;
}

sub validatedate{

print "validating date...\n";
if($_[0] =~ /([0-9]{1,2})[\/]([0-9]{1,2})[\/]([0-9]{4})/ )
{
	if (($1 >31)||($1 < 0)) {print "Not a valid date\n";return 0;}
	if (($2 >12)||($1 <0)) {print "Not a valid date\n";return 0;}
	if  ($3 <0) {print "Not a valid date\n";return 0;}
	if ( ($1 == 31) && (! (($2==1)||($2==3)||($2==3)||($2==5)||($2==7)||($2==8)||($2==10)||($2==12)) ) ) {print "Not a valid date\n";return 0;}
	if (($1==30)&&($2==2)) {print "Not a valid date\n";return 0;}
	if (($1==29)&&(!isleapyear($3))) {print "Not a valid date\n";return 0;}
	return 1;  
}
else {return 0;}

}
sub checkdateformat{
print $_[0];
while ((!($_[0] =~ /([0-9]{1,2})[\/]([0-9]{1,2})[\/]([0-9]{4})/ ))||(validatedate($_[0])==0))
{
	print "Date Format is Wrong OR Date is empty.\nPlase Reenter the Date in (DD/MM/YYYY) format:";
	$_[0]=<STDIN>;
}
}

if(($#ARGV+1)<1)
{
 print "Usage:perl test.pl <filename>\n";
 exit 0;
}

open(configFile,$ARGV[0]) ||die("Can Not Open a input file\n");
$flag=0;
while(<configFile>)
{
	if($flag==0)
	{
		s/^\s+//;
		if($_ ne "")
		{
			($fieldName,$fieldValue)=split(/\s*:\s*/,$_,2);
			$fields{$fieldName}=$fieldValue;
		}
		
		else
		{
			#print "blank line";
			$flag=1;$fields{"message"}="";
		}
	}
	else
	{
		$fields{"message"}=$fields{"message"}.$_;
	}
}

#foreach $name (keys %fields)
#{
#	print $name,$fields{$name};
#}
print "--------------------------------\n";

while (!$fields{"Name"})
{	
	print "Compulsory Field Name Not Present\n";
	do{
	print "Please Enter Your Name:";
	$fields{"Name"}=<STDIN>;
	#print $fields{"Name"};
	}while($fields{"Name"} eq "\n");
}
while (!$fields{"From"})
{
        print "Compulsory Field From Not Present\n";
	do{
	print "Please Enter the From field:";
        $fields{"From"}=<STDIN>;
	}while($fields{"From"} eq "\n");
}
while (!$fields{"Date"})
{
        print "Compulsory Field Date Not Present\n";
	#do{
	#print "Please Enter the Date(DD/MM/YYYY):";
        #$fields{"Date"}=<STDIN>;
	checkdateformat($fields{"Date"});
	
	#}while($fields{"Date"} eq "\n");
}
while (!$fields{"NG"})
{
        print "Compulsory Field NG Not Present\n";
	do{
	print "Please Enter the NG:";
        $fields{"NG"}=<STDIN>;
	}while($fields{"NG"} eq "\n");
}
while (!$fields{"Sub"})
{
        print "Compulsory Field Sub Not Present\n";
	do{
	print "Please Enter the Subject:";
        $fields{"Sub"}=<STDIN>;
	}while($fields{"Sub"} eq "\n");
}

checkdateformat($fields{"Date"});
if($fields{"Date"} =~ /([0-9]{1,2})[\/]([0-9]{1,2})[\/]([0-9]{4})/ ) {
        $fields{"Date"}=$2."\/".$1."\/".$3."\n";
        print("Date: ",$fields{"Date"},"\n");

}
if($fields{"Exp"})
{
print "Checking the expiry Date Format....\n";
checkdateformat($fields{"Exp"});
if($fields{"Exp"} =~ /([0-9]{1,2})[\/]([0-9]{1,2})[\/]([0-9]{4})/ ) {
        $fields{"Exp"}=$2."\/".$1."\/".$3."\n";
        print("Exp: ",$fields{"Exp"},"\n");

}
}

open(tempFile,"+>temp") ||die("Can Not Open a input file\n");
print tempFile "Name: ".$fields{"Name"};
print tempFile "From: ".$fields{"From"};
print tempFile "Date: ".$fields{"Date"};
print tempFile "Newsgroups: ".$fields{"NG"};
print tempFile "Subject: ".$fields{"Sub"};
if ($fields{"ReplyTo"}) 
{
	print tempFile "ReplyTo: ".$fields{"ReplyTo"};
}
if ($fields{"Sender"})
{
        print tempFile "Sender: ".$fields{"Sender"};
}
if ($fields{"Exp"})
{
        print tempFile "Exp: ".$fields{"Exp"};
}
print tempFile "\n";
print tempFile $fields{"message"};
print tempFile "\n";
print tempFile "-----------------------------------------------------------\n";
print tempFile "-".$fields{"Name"};
print tempFile `date`;
print tempFile `/usr/games/fortune`;
print tempFile "-----------------------------------------------------------\n";

close(tempFile);


my $MyClient = new Net::NNTP::Client("jeeves.cse.iitb.ac.in","server" => "jeeves.cse.iitb.ac.in","port" => 119) || die("Can not craete a client");


if(($MyClient->connected())==0)
{
        $MyClient->connect();
	#print("bfr not connected");

}
if($MyClient->connected()==1)
{
chomp($fields{"NG"});
$MyClient->group($fields{"NG"});
if($MyClient->postok())
{
  	printf("posting\n");
	open(tempFile, "temp") or die "Cannot read temporary file";
	$MyClient->post(<tempFile>) or die "Could not post article: $!";
        close(tempFile);
	printf("done\n");
}
else{print ("NewsGroup Not Ready");}
}
else
{
print "Some Unknown Problem";
}

$MyClient->disconnect();
`rm -f temp`;
