#!/bin/sh
# This is a comment!
cp $0 ../replace2.sh
rm -f temp1

error()
{
        case $1 in
                1)
                        echo "Invalid Option"
                        echo "Try 'sh replace1.sh -help' for more information."
                        break
                        ;;
                2)
                        echo "Usage:sh replace1.sh -z <size> -s1 <string1> -s2 <string2> -o <outputfile>"
                        break
                        ;;
                3)
                        echo "Not a correct Usage";
                        echo "Try 'sh replace1.sh -help' for more information."
                        break
                        ;;
        esac
        exit 0;
}


if [ $# != 8 ]
then
	
        if [ $# == 0 ]
        then
                error 2
        elif [ $# == 1 ]
        then
                if [ "$1" == "-help" ]
                then
                        error 2
                else
                        error 3
                fi
        else
                error 3
        fi

fi

if [ "$1" == "-z" ]
then
	if [ "$3" == "-s1" ]
	then
		if [ "$5" == "-s2" ]
		then
			if [ "$7" == "-o" ]
			then
				rm -f $8
				echo "Modified Files"
				filenames=`find . -size +${2}c -type f`
				for file in $filenames
				do
					no=`grep -cI $4 $file`
					echo "$no:$file" >>temp1	
				done
				filenames=`sort -nr temp1|cut -d: -f2`
				for file in $filenames
				do
					grep -I $4 $file >>$8
					no=`grep -cI $4 $file`
        				sed s/$4/$6/g $file -i
					#echo $no
					if [ "$no" != "0" ]
					then
						echo >>$8
						echo $file
					fi 
					#echo $file
				done
				sed s/$4/$6/g $8 -i
				rm -f temp1
				#echo yes
			else
			        error 1
			fi
		else
        		error 1
		fi
	else
        	error 1
	fi
else
	error 1	
fi 

